/**********************************************************************************
 * ļ  W5500.c
 *     W5500 
**********************************************************************************/
#include "stm32f10x.h"
#include "stm32f10x_spi.h"				
#include "W5500.h"	

/***************-----  -----***************/
unsigned char Gateway_IP[4];		//IPַ 
unsigned char Sub_Mask[4];			// 
unsigned char Phy_Addr[6];			//ַ(MAC) 
unsigned char IP_Addr[4];				//IPַ 

unsigned char S0_Port[2];				//˿0Ķ˿ں(5000) 
unsigned char S0_DIP[4];				//˿0ĿIPַ 
unsigned char S0_DPort[2];			//˿0ĿĶ˿ں(6000) 

unsigned char UDP_DIPR[4];			//UDP(㲥)ģʽ,ĿIPַ
unsigned char UDP_DPORT[2];			//UDP(㲥)ģʽ,Ŀ˿ں

/***************----- ˿ڵģʽ -----***************/
unsigned char S0_Mode =3;				//˿0ģʽ,0:TCPģʽ,1:TCPͻģʽ,2:UDP(㲥)ģʽ
#define TCP_SERVER	0x00				//TCPģʽ
#define TCP_CLIENT	0x01				//TCPͻģʽ 
#define UDP_MODE	0x02					//UDP(㲥)ģʽ 

/***************----- ˿ڵ״̬ -----***************/
unsigned char S0_State =0;			//˿0״̬¼,1:˿ɳʼ,2˿() 
#define S_INIT		0x01					//˿ɳʼ 
#define S_CONN		0x02					//˿, 

/***************----- ˿շݵ״̬ -----***************/
unsigned char S0_Data;					//˿0պͷݵ״̬,1:˿ڽյ,2:˿ڷ 
#define S_RECEIVE	 0x01					//˿ڽյһݰ 
#define S_TRANSMITOK 0x02				//˿ڷһݰ 

/***************----- ˿ݻ -----***************/
unsigned char Rx_Buffer[2048];	//˿ڽݻ 
unsigned char Tx_Buffer[2048];	//˿ڷݻ 

unsigned char W5500_Interrupt;	//W5500жϱ־(0:ж,1:ж)

/*******************************************************************************
*   : W5500_GPIO_Configuration
*     : W5500 GPIOʼ
*     : 
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void W5500_GPIO_Configuration(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;	

	/* W5500_RSTųʼ(PC5) */
	GPIO_InitStructure.GPIO_Pin  = W5500_RST;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(W5500_RST_PORT, &GPIO_InitStructure);
	GPIO_ResetBits(W5500_RST_PORT, W5500_RST);
}

/*******************************************************************************
*   : SPI_Configuration
*     : W5500 SPIʼ(STM32 SPI1)
*     : 
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void SPI_Configuration(void)
{
	GPIO_InitTypeDef 	GPIO_InitStructure;
	SPI_InitTypeDef   	SPI_InitStructure;	   

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_SPI1 | RCC_APB2Periph_AFIO, ENABLE);	

	/* ʼSCKMISOMOSI */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIO_SetBits(GPIOA,GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7);

	/* ʼCS */
	GPIO_InitStructure.GPIO_Pin = W5500_SCS;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_Init(W5500_SCS_PORT, &GPIO_InitStructure);
	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS);

	/* ʼSTM32 SPI1 */
	SPI_InitStructure.SPI_Direction=SPI_Direction_2Lines_FullDuplex;	//SPIΪ˫˫ȫ˫
	SPI_InitStructure.SPI_Mode=SPI_Mode_Master;												//ΪSPI
	SPI_InitStructure.SPI_DataSize=SPI_DataSize_8b;										//SPIͽ8λ֡ṹ
	SPI_InitStructure.SPI_CPOL=SPI_CPOL_Low;													//ʱյ
	SPI_InitStructure.SPI_CPHA=SPI_CPHA_1Edge;												//ݲڵ1ʱ
	SPI_InitStructure.SPI_NSS=SPI_NSS_Soft;														//NSSⲿܽŹ
	SPI_InitStructure.SPI_BaudRatePrescaler=SPI_BaudRatePrescaler_2;	//ԤƵֵΪ2
	SPI_InitStructure.SPI_FirstBit=SPI_FirstBit_MSB;									//ݴMSBλʼ
	SPI_InitStructure.SPI_CRCPolynomial=7;														//CRCʽΪ7
	SPI_Init(SPI1,&SPI_InitStructure);																//SPI_InitStructָĲʼSPI1Ĵ

	SPI_Cmd(SPI1,ENABLE);	//STM32ʹSPI1
}

/*******************************************************************************
*   : SPI1_Send_Byte
*     : SPI11ֽ
*     : dat:͵
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void SPI1_Send_Byte(unsigned char dat)
{
	SPI_I2S_SendData(SPI1,dat);//д1ֽ
	while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET);//ȴݼĴ
}

/*******************************************************************************
*   : SPI1_Send_Short
*     : SPI12ֽ(16λ)
*     : dat:͵16λ
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void SPI1_Send_Short(unsigned short dat)
{
	SPI1_Send_Byte(dat/256);//дݸλ
	SPI1_Send_Byte(dat);	//дݵλ
}

/*******************************************************************************
*   : Write_W5500_1Byte
*     : ͨSPI1ַָĴд1ֽ
*     : reg:16λĴַ,dat:д
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void Write_W5500_1Byte(unsigned short reg, unsigned char dat)
{
	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ

	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM1|RWB_WRITE|COMMON_R);//ͨSPI1дֽ,1ֽݳ,д,ѡͨüĴ
	SPI1_Send_Byte(dat);//д1ֽ

	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS); //W5500SCSΪߵƽ
}

/*******************************************************************************
*   : Write_W5500_2Byte
*     : ͨSPI1ַָĴд2ֽ
*     : reg:16λĴַ,dat:16λд(2ֽ)
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void Write_W5500_2Byte(unsigned short reg, unsigned short dat)
{
	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ
		
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM2|RWB_WRITE|COMMON_R);//ͨSPI1дֽ,2ֽݳ,д,ѡͨüĴ
	SPI1_Send_Short(dat);//д16λ

	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS); //W5500SCSΪߵƽ
}

/*******************************************************************************
*   : Write_W5500_nByte
*     : ͨSPI1ַָĴдnֽ
*     : reg:16λĴַ,*dat_ptr:дݻָ,size:дݳ
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void Write_W5500_nByte(unsigned short reg, unsigned char *dat_ptr, unsigned short size)
{
	unsigned short i;

	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ	
		
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(VDM|RWB_WRITE|COMMON_R);//ͨSPI1дֽ,Nֽݳ,д,ѡͨüĴ

	for(i=0;i<size;i++)//ѭsizeֽдW5500
	{
		SPI1_Send_Byte(*dat_ptr++);//дһֽ
	}

	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS); //W5500SCSΪߵƽ
}

/*******************************************************************************
*   : Write_W5500_SOCK_1Byte
*     : ͨSPI1ָ˿ڼĴд1ֽ
*     : s:˿ں,reg:16λĴַ,dat:д
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void Write_W5500_SOCK_1Byte(SOCKET s, unsigned short reg, unsigned char dat)
{
	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ	
		
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM1|RWB_WRITE|(s*0x20+0x08));//ͨSPI1дֽ,1ֽݳ,д,ѡ˿sļĴ
	SPI1_Send_Byte(dat);//д1ֽ

	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS); //W5500SCSΪߵƽ
}

/*******************************************************************************
*   : Write_W5500_SOCK_2Byte
*     : ͨSPI1ָ˿ڼĴд2ֽ
*     : s:˿ں,reg:16λĴַ,dat:16λд(2ֽ)
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void Write_W5500_SOCK_2Byte(SOCKET s, unsigned short reg, unsigned short dat)
{
	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ
			
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM2|RWB_WRITE|(s*0x20+0x08));//ͨSPI1дֽ,2ֽݳ,д,ѡ˿sļĴ
	SPI1_Send_Short(dat);//д16λ

	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS); //W5500SCSΪߵƽ
}

/*******************************************************************************
*   : Write_W5500_SOCK_4Byte
*     : ͨSPI1ָ˿ڼĴд4ֽ
*     : s:˿ں,reg:16λĴַ,*dat_ptr:д4ֽڻָ
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void Write_W5500_SOCK_4Byte(SOCKET s, unsigned short reg, unsigned char *dat_ptr)
{
	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ
			
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM4|RWB_WRITE|(s*0x20+0x08));//ͨSPI1дֽ,4ֽݳ,д,ѡ˿sļĴ

	SPI1_Send_Byte(*dat_ptr++);//д1ֽ
	SPI1_Send_Byte(*dat_ptr++);//д2ֽ
	SPI1_Send_Byte(*dat_ptr++);//д3ֽ
	SPI1_Send_Byte(*dat_ptr++);//д4ֽ

	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS); //W5500SCSΪߵƽ
}

/*******************************************************************************
*   : Read_W5500_1Byte
*     : W5500ַָĴ1ֽ
*     : reg:16λĴַ
*     : 
* ֵ  : ȡĴ1ֽ
* ˵    : 
*******************************************************************************/
unsigned char Read_W5500_1Byte(unsigned short reg)
{
	unsigned char i;

	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ
			
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM1|RWB_READ|COMMON_R);//ͨSPI1дֽ,1ֽݳ,,ѡͨüĴ

	i=SPI_I2S_ReceiveData(SPI1);
	SPI1_Send_Byte(0x00);//һ
	i=SPI_I2S_ReceiveData(SPI1);//ȡ1ֽ

	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪߵƽ
	return i;//ضȡļĴ
}

/*******************************************************************************
*   : Read_W5500_SOCK_1Byte
*     : W5500ָ˿ڼĴ1ֽ
*     : s:˿ں,reg:16λĴַ
*     : 
* ֵ  : ȡĴ1ֽ
* ˵    : 
*******************************************************************************/
unsigned char Read_W5500_SOCK_1Byte(SOCKET s, unsigned short reg)
{
	unsigned char i;

	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ
			
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM1|RWB_READ|(s*0x20+0x08));//ͨSPI1дֽ,1ֽݳ,,ѡ˿sļĴ

	i=SPI_I2S_ReceiveData(SPI1);
	SPI1_Send_Byte(0x00);//һ
	i=SPI_I2S_ReceiveData(SPI1);//ȡ1ֽ

	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪߵƽ
	return i;//ضȡļĴ
}

/*******************************************************************************
*   : Read_W5500_SOCK_2Byte
*     : W5500ָ˿ڼĴ2ֽ
*     : s:˿ں,reg:16λĴַ
*     : 
* ֵ  : ȡĴ2ֽ(16λ)
* ˵    : 
*******************************************************************************/
unsigned short Read_W5500_SOCK_2Byte(SOCKET s, unsigned short reg)
{
	unsigned short i;

	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ
			
	SPI1_Send_Short(reg);//ͨSPI1д16λĴַ
	SPI1_Send_Byte(FDM2|RWB_READ|(s*0x20+0x08));//ͨSPI1дֽ,2ֽݳ,,ѡ˿sļĴ

	i=SPI_I2S_ReceiveData(SPI1);
	SPI1_Send_Byte(0x00);//һ
	i=SPI_I2S_ReceiveData(SPI1);//ȡλ
	SPI1_Send_Byte(0x00);//һ
	i*=256;
	i+=SPI_I2S_ReceiveData(SPI1);//ȡλ

	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪߵƽ
	return i;//ضȡļĴ
}

/*******************************************************************************
*   : Read_SOCK_Data_Buffer
*     : W5500ݻжȡ
*     : s:˿ں,*dat_ptr:ݱ滺ָ
*     : 
* ֵ  : ȡݳ,rx_sizeֽ
* ˵    : 
*******************************************************************************/
unsigned short Read_SOCK_Data_Buffer(SOCKET s, unsigned char *dat_ptr)
{
	unsigned short rx_size;
	unsigned short offset, offset1;
	unsigned short i;
	unsigned char j;

	rx_size=Read_W5500_SOCK_2Byte(s,Sn_RX_RSR);
	if(rx_size==0) return 0;//ûյ򷵻
	if(rx_size>1460) rx_size=1460;

	offset=Read_W5500_SOCK_2Byte(s,Sn_RX_RD);
	offset1=offset;
	offset&=(S_RX_SIZE-1);//ʵʵַ

	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ

	SPI1_Send_Short(offset);//д16λַ
	SPI1_Send_Byte(VDM|RWB_READ|(s*0x20+0x18));//дֽ,Nֽݳ,,ѡ˿sļĴ
	j=SPI_I2S_ReceiveData(SPI1);
	
	if((offset+rx_size)<S_RX_SIZE)//ַδW5500ջĴַ
	{
		for(i=0;i<rx_size;i++)//ѭȡrx_sizeֽ
		{
			SPI1_Send_Byte(0x00);//һ
			j=SPI_I2S_ReceiveData(SPI1);//ȡ1ֽ
			*dat_ptr=j;//ȡݱ浽ݱ滺
			dat_ptr++;//ݱ滺ַָ1
		}
	}
	else//ַW5500ջĴַ
	{
		offset=S_RX_SIZE-offset;
		for(i=0;i<offset;i++)//ѭȡǰoffsetֽ
		{
			SPI1_Send_Byte(0x00);//һ
			j=SPI_I2S_ReceiveData(SPI1);//ȡ1ֽ
			*dat_ptr=j;//ȡݱ浽ݱ滺
			dat_ptr++;//ݱ滺ַָ1
		}
		GPIO_SetBits(W5500_SCS_PORT, W5500_SCS); //W5500SCSΪߵƽ

		GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ

		SPI1_Send_Short(0x00);//д16λַ
		SPI1_Send_Byte(VDM|RWB_READ|(s*0x20+0x18));//дֽ,Nֽݳ,,ѡ˿sļĴ
		j=SPI_I2S_ReceiveData(SPI1);

		for(;i<rx_size;i++)//ѭȡrx_size-offsetֽ
		{
			SPI1_Send_Byte(0x00);//һ
			j=SPI_I2S_ReceiveData(SPI1);//ȡ1ֽ
			*dat_ptr=j;//ȡݱ浽ݱ滺
			dat_ptr++;//ݱ滺ַָ1
		}
	}
	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS); //W5500SCSΪߵƽ

	offset1+=rx_size;//ʵַ,´ζȡյݵʼַ
	Write_W5500_SOCK_2Byte(s, Sn_RX_RD, offset1);
	Write_W5500_SOCK_1Byte(s, Sn_CR, RECV);//
	return rx_size;//ؽյݵĳ
}

/*******************************************************************************
*   : Write_SOCK_Data_Buffer
*     : дW5500ݷͻ
*     : s:˿ں,*dat_ptr:ݱ滺ָ,size:дݵĳ
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void Write_SOCK_Data_Buffer(SOCKET s, unsigned char *dat_ptr, unsigned short size)
{
	unsigned short offset,offset1;
	unsigned short i;

	//UDPģʽ,ڴĿIPͶ˿ں
	if((Read_W5500_SOCK_1Byte(s,Sn_MR)&0x0f) != SOCK_UDP)//Socketʧ
	{		
		Write_W5500_SOCK_4Byte(s, Sn_DIPR, UDP_DIPR);//ĿIP  		
		Write_W5500_SOCK_2Byte(s, Sn_DPORTR, UDP_DPORT[0]*256+UDP_DPORT[1]);//Ŀ˿ں				
	}

	offset=Read_W5500_SOCK_2Byte(s,Sn_TX_WR);
	offset1=offset;
	offset&=(S_TX_SIZE-1);//ʵʵַ

	GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ

	SPI1_Send_Short(offset);//д16λַ
	SPI1_Send_Byte(VDM|RWB_WRITE|(s*0x20+0x10));//дֽ,Nֽݳ,д,ѡ˿sļĴ

	if((offset+size)<S_TX_SIZE)//ַδW5500ͻĴַ
	{
		for(i=0;i<size;i++)//ѭдsizeֽ
		{
			SPI1_Send_Byte(*dat_ptr++);//дһֽڵ		
		}
	}
	else//ַW5500ͻĴַ
	{
		offset=S_TX_SIZE-offset;
		for(i=0;i<offset;i++)//ѭдǰoffsetֽ
		{
			SPI1_Send_Byte(*dat_ptr++);//дһֽڵ
		}
		GPIO_SetBits(W5500_SCS_PORT, W5500_SCS); //W5500SCSΪߵƽ

		GPIO_ResetBits(W5500_SCS_PORT, W5500_SCS);//W5500SCSΪ͵ƽ

		SPI1_Send_Short(0x00);//д16λַ
		SPI1_Send_Byte(VDM|RWB_WRITE|(s*0x20+0x10));//дֽ,Nֽݳ,д,ѡ˿sļĴ

		for(;i<size;i++)//ѭдsize-offsetֽ
		{
			SPI1_Send_Byte(*dat_ptr++);//дһֽڵ
		}
	}
	GPIO_SetBits(W5500_SCS_PORT, W5500_SCS); //W5500SCSΪߵƽ

	offset1+=size;//ʵַ,´дݵݻʼַ
	Write_W5500_SOCK_2Byte(s, Sn_TX_WR, offset1);
	Write_W5500_SOCK_1Byte(s, Sn_CR, SEND);//				
}

/*******************************************************************************
*   : W5500_Hardware_Reset
*     : ӲλW5500
*     : 
*     : 
* ֵ  : 
* ˵    : W5500ĸλűֵ͵ƽ500us,ΧW5500
*******************************************************************************/
void W5500_Hardware_Reset(void)
{
	GPIO_ResetBits(W5500_RST_PORT, W5500_RST);//λ
	Delay(50);
	GPIO_SetBits(W5500_RST_PORT, W5500_RST);//λ
	Delay(200);
	while((Read_W5500_1Byte(PHYCFGR)&LINK)==0);//ȴ̫
}

/*******************************************************************************
*   : W5500_Init
*     : ʼW5500Ĵ
*     : 
*     : 
* ֵ  : 
* ˵    : ʹW5500֮ǰȶW5500ʼ
*******************************************************************************/
void W5500_Init(void)
{
	u8 i=0;

	Write_W5500_1Byte(MR, RST);//λW5500,1Ч,λԶ0
	Delay(10);//ʱ10ms,Լú

	//(Gateway)IPַ,Gateway_IPΪ4ֽunsigned char,Լ 
	//ʹؿʹͨͻľޣͨؿԷʵInternet
	Write_W5500_nByte(GAR, Gateway_IP, 4);
			
	//(MASK)ֵ,SUB_MASKΪ4ֽunsigned char,Լ
	//
	Write_W5500_nByte(SUBR,Sub_Mask,4);		
	
	//ַ,PHY_ADDRΪ6ֽunsigned char,Լ,Ψһʶ豸ֵַ
	//õֵַҪIEEE룬OUIĹ涨ǰ3ֽΪ̴룬ֽΪƷ
	//ԼַעһֽڱΪż
	Write_W5500_nByte(SHAR,Phy_Addr,6);		

	//ñIPַ,IP_ADDRΪ4ֽunsigned char,Լ
	//ע⣬IP뱾IPͬһ򱾻޷ҵ
	Write_W5500_nByte(SIPR,IP_Addr,4);		
	
	//÷ͻͽջĴСοW5500ֲ
	for(i=0;i<8;i++)
	{
		Write_W5500_SOCK_1Byte(i,Sn_RXBUF_SIZE, 0x02);//Socket Rx memory size=2k
		Write_W5500_SOCK_1Byte(i,Sn_TXBUF_SIZE, 0x02);//Socket Tx mempry size=2k
	}

	//ʱ䣬ĬΪ2000(200ms) 
	//ÿһλֵΪ100΢,ʼʱֵΪ2000(0x07D0),200
	Write_W5500_2Byte(RTR, 0x07d0);

	//ԴĬΪ8 
	//طĴ趨ֵ,ʱж(صĶ˿жϼĴеSn_IR ʱλ(TIMEOUT)á1)
	Write_W5500_1Byte(RCR,8);
}

/*******************************************************************************
*   : Detect_Gateway
*     : ط
*     : 
*     : 
* ֵ  : ɹTRUE(0xFF),ʧܷFALSE(0x00)
* ˵    : 
*******************************************************************************/
unsigned char Detect_Gateway(void)
{
	unsigned char ip_adde[4];
	ip_adde[0]=IP_Addr[0]+1;
	ip_adde[1]=IP_Addr[1]+1;
	ip_adde[2]=IP_Addr[2]+1;
	ip_adde[3]=IP_Addr[3]+1;

	//ؼȡصַ
	Write_W5500_SOCK_4Byte(0,Sn_DIPR,ip_adde);//ĿĵַĴд뱾IPͬIPֵ
	Write_W5500_SOCK_1Byte(0,Sn_MR,MR_TCP);//socketΪTCPģʽ
	Write_W5500_SOCK_1Byte(0,Sn_CR,OPEN);//Socket	
	Delay(5);//ʱ5ms 	
	
	if(Read_W5500_SOCK_1Byte(0,Sn_SR) != SOCK_INIT)//socketʧ
	{
		Write_W5500_SOCK_1Byte(0,Sn_CR,CLOSE);//򿪲ɹ,رSocket
		return FALSE;//FALSE(0x00)
	}

	Write_W5500_SOCK_1Byte(0,Sn_CR,CONNECT);//SocketΪConnectģʽ						

	do
	{
		u8 j=0;
		j=Read_W5500_SOCK_1Byte(0,Sn_IR);//ȡSocket0жϱ־Ĵ
		if(j!=0)
		Write_W5500_SOCK_1Byte(0,Sn_IR,j);
		Delay(5);//ʱ5ms 
		if((j&IR_TIMEOUT) == IR_TIMEOUT)
		{
			return FALSE;	
		}
		else if(Read_W5500_SOCK_1Byte(0,Sn_DHAR) != 0xff)
		{
			Write_W5500_SOCK_1Byte(0,Sn_CR,CLOSE);//رSocket
			return TRUE;							
		}
	}while(1);
}

/*******************************************************************************
*   : Socket_Init
*     : ָSocket(0~7)ʼ
*     : s:ʼĶ˿
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void Socket_Init(SOCKET s)
{
	//÷ƬȣοW5500ֲᣬֵԲ޸	
	Write_W5500_SOCK_2Byte(0, Sn_MSSR, 1460);//Ƭֽ=1460(0x5b4)
	//ָ˿
	switch(s)
	{
		case 0:
			//ö˿0Ķ˿ں
			Write_W5500_SOCK_2Byte(0, Sn_PORT, S0_Port[0]*256+S0_Port[1]);
			//ö˿0Ŀ(Զ)˿ں
			Write_W5500_SOCK_2Byte(0, Sn_DPORTR, S0_DPort[0]*256+S0_DPort[1]);
			//ö˿0Ŀ(Զ)IPַ
			Write_W5500_SOCK_4Byte(0, Sn_DIPR, S0_DIP);			
			
			break;

		case 1:
			break;

		case 2:
			break;

		case 3:
			break;

		case 4:
			break;

		case 5:
			break;

		case 6:
			break;

		case 7:
			break;

		default:
			break;
	}
}

/*******************************************************************************
*   : Socket_Connect
*     : ָSocket(0~7)ΪͻԶ̷
*     : s:趨Ķ˿
*     : 
* ֵ  : ɹTRUE(0xFF),ʧܷFALSE(0x00)
* ˵    : Socketڿͻģʽʱ,øó,Զ̷
*			Ӻֳʱжϣʧ,Ҫµøó
*			óÿһ,һ
*******************************************************************************/
unsigned char Socket_Connect(SOCKET s)
{
	Write_W5500_SOCK_1Byte(s,Sn_MR,MR_TCP);//socketΪTCPģʽ
	Write_W5500_SOCK_1Byte(s,Sn_CR,OPEN);//Socket
	Delay(5);//ʱ5ms
	if(Read_W5500_SOCK_1Byte(s,Sn_SR)!=SOCK_INIT)//socketʧ
	{
		Write_W5500_SOCK_1Byte(s,Sn_CR,CLOSE);//򿪲ɹ,رSocket
		return FALSE;//FALSE(0x00)
	}
	Write_W5500_SOCK_1Byte(s,Sn_CR,CONNECT);//SocketΪConnectģʽ
	return TRUE;//TRUE,óɹ
}

/*******************************************************************************
*   : Socket_Listen
*     : ָSocket(0~7)ΪȴԶ
*     : s:趨Ķ˿
*     : 
* ֵ  : ɹTRUE(0xFF),ʧܷFALSE(0x00)
* ˵    : Socketڷģʽʱ,øó,ȵԶ
*			óֻһ,ʹW5500Ϊģʽ
*******************************************************************************/
unsigned char Socket_Listen(SOCKET s)
{
	Write_W5500_SOCK_1Byte(s,Sn_MR,MR_TCP);//socketΪTCPģʽ 
	Write_W5500_SOCK_1Byte(s,Sn_CR,OPEN);//Socket	
	Delay(5);//ʱ5ms
	if(Read_W5500_SOCK_1Byte(s,Sn_SR)!=SOCK_INIT)//socketʧ
	{
		Write_W5500_SOCK_1Byte(s,Sn_CR,CLOSE);//򿪲ɹ,رSocket
		return FALSE;//FALSE(0x00)
	}	
	Write_W5500_SOCK_1Byte(s,Sn_CR,LISTEN);//SocketΪģʽ	
	Delay(5);//ʱ5ms
	if(Read_W5500_SOCK_1Byte(s,Sn_SR)!=SOCK_LISTEN)//socketʧ
	{
		Write_W5500_SOCK_1Byte(s,Sn_CR,CLOSE);//òɹ,رSocket
		return FALSE;//FALSE(0x00)
	}

	return TRUE;

	//SocketĴ򿪺,Զ̿ͻǷ,ҪȴSocketжϣ
	//жSocketǷɹοW5500ֲSocketж״̬
	//ڷģʽҪĿIPĿĶ˿ں
}

/*******************************************************************************
*   : Socket_UDP
*     : ָSocket(0~7)ΪUDPģʽ
*     : s:趨Ķ˿
*     : 
* ֵ  : ɹTRUE(0xFF),ʧܷFALSE(0x00)
* ˵    : SocketUDPģʽ,øó,UDPģʽ,SocketͨŲҪ
*			óֻһΣʹW5500ΪUDPģʽ
*******************************************************************************/
unsigned char Socket_UDP(SOCKET s)
{
	Write_W5500_SOCK_1Byte(s,Sn_MR,MR_UDP);//SocketΪUDPģʽ*/
	Write_W5500_SOCK_1Byte(s,Sn_CR,OPEN);//Socket*/
	Delay(5);//ʱ5ms
	if(Read_W5500_SOCK_1Byte(s,Sn_SR)!=SOCK_UDP)//Socketʧ
	{
		Write_W5500_SOCK_1Byte(s,Sn_CR,CLOSE);//򿪲ɹ,رSocket
		return FALSE;//FALSE(0x00)
	}
	else
		return TRUE;

	//SocketĴ򿪺UDPģʽ,ģʽҪԶ
	//ΪSocketҪ,ڷǰĿIPĿSocketĶ˿ں
	//ĿIPĿSocketĶ˿ںǹ̶,йûиı,ôҲ
}

/*******************************************************************************
*   : W5500_Interrupt_Process
*     : W5500жϴ
*     : 
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void W5500_Interrupt_Process(void)
{
	unsigned char i,j;

IntDispose:

	i=Read_W5500_1Byte(SIR);//ȡ˿жϱ־Ĵ	
	if((i & S0_INT) == S0_INT)//Socket0¼ 
	{
		j=Read_W5500_SOCK_1Byte(0,Sn_IR);//ȡSocket0жϱ־Ĵ
		Write_W5500_SOCK_1Byte(0,Sn_IR,j);
		if(j&IR_CON)//TCPģʽ,Socket0ɹ 
		{
			S0_State|=S_CONN;//״̬0x02,˿ӣ
		}
		if(j&IR_DISCON)//TCPģʽSocketϿӴ
		{
			Write_W5500_SOCK_1Byte(0,Sn_CR,CLOSE);//رն˿,ȴ´ 
			Socket_Init(0);		//ָSocket(0~7)ʼ,ʼ˿0
			S0_State=0;//״̬0x00,˿ʧ
		}
		if(j&IR_SEND_OK)//Socket0ݷ,ٴS_tx_process() 
		{
			S0_Data|=S_TRANSMITOK;//˿ڷһݰ 
		}
		if(j&IR_RECV)//Socketյ,S_rx_process() 
		{
			S0_Data|=S_RECEIVE;//˿ڽյһݰ
		}
		if(j&IR_TIMEOUT)//Socketӻݴ䳬ʱ 
		{
			Write_W5500_SOCK_1Byte(0,Sn_CR,CLOSE);// رն˿,ȴ´ 			
			S0_State=0;//״̬0x00,˿ʧ
		}
	}

	if(Read_W5500_1Byte(SIR) != 0) 
		goto IntDispose;
}

