/**********************************************************************************
 * ļ  W5500_USER.c
 *     W5500 
**********************************************************************************/
#include "stm32f10x.h"
#include "W5500.h"
#include <string.h>

unsigned int Timer2_Counter = 0; 								//Timer2ʱ(ms)
unsigned int W5500_Send_Delay_Counter = 0;			//W5500ʱ(ms)

/*******************************************************************************
*   :	RCC_Configuration
*     :	ϵͳʱΪ72MHZ(ԸҪ)
*     :	
*     :	
* ֵ  :	
* ˵    :	STM32F107xSTM32F105xϵMCUSTM32F103xϵMCUʱͬ
*******************************************************************************/
void RCC_Configuration(void)
{
  ErrorStatus HSEStartUpStatus;               //ⲿʱ(HSE)Ĺ״̬
  
  RCC_DeInit();                               //RCCãʱصļĴΪĬֵ
  RCC_HSEConfig(RCC_HSE_ON);                  //ⲿʱHSE 
  HSEStartUpStatus = RCC_WaitForHSEStartUp(); //ȴⲿʱ(HSE)ȶ

  if(SUCCESS == HSEStartUpStatus)             //ⲿʱѾȶ
  {
    /* Flash洢 */
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable); //FlashԤȡ
    FLASH_SetLatency(FLASH_Latency_2);										//Flashӳ״̬Ϊ2ΪӦ72MHzĸƵʱ
    
		/* ʱӷƵ */
    RCC_HCLKConfig(RCC_SYSCLK_Div1); 					//AHBʱӵϵͳʱ(1Ƶ)/72MHZ
    RCC_PCLK2Config(RCC_HCLK_Div1);  					//APB2ʱӺHCLKʱ/72MHz(Ϊ72MHz)
    RCC_PCLK1Config(RCC_HCLK_Div2);  					//APB1ʱHCLKʱӵ2Ƶ/36MHz(Ϊ36MHz)
		
		/* PLL */
#ifndef STM32F10X_CL                 											//ʹõĲSTM32F10X_CLϵУSTM32F103xϵУMCU,PLL  
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9); 	//PLLΪHSEƵPLLƵΪ9PLLCLK = 8MHz * 9 = 72 MHz 
#else                                											//ʹõSTM32F10X_CLϵ(STM32F107xSTM32F105xϵУMCU,PLL
    /***** PLLx *****/
    /* PLL2ƵΪ5PLL2ƵΪ8: PLL2CLK = (HSE / 5) * 8 = 40 MHz */
    RCC_PREDIV2Config(RCC_PREDIV2_Div5);
    RCC_PLL2Config(RCC_PLL2Mul_8);

    RCC_PLL2Cmd(ENABLE); 																					//ʹPLL2 
    while (RCC_GetFlagStatus(RCC_FLAG_PLL2RDY) == RESET);					//ȴPLL2ȶ

    /* PLL1ΪPLL2Ƶ5PLL1ıƵΪ9: PLLCLK = (PLL2 / 5) * 9 = 72 MHz */ 
    RCC_PREDIV1Config(RCC_PREDIV1_Source_PLL2, RCC_PREDIV1_Div5);
    RCC_PLLConfig(RCC_PLLSource_PREDIV1, RCC_PLLMul_9);
#endif

    RCC_PLLCmd(ENABLE); 																		//ʹPLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);			//ȴPLLȶ

    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);							//ϵͳʱӵʱԴΪPLL

    while(RCC_GetSYSCLKSource() != 0x08);										//ϵͳʱԴǷPLL
    RCC_ClockSecuritySystemCmd(ENABLE);											//ʱӰȫϵͳHSEʱԶлڲʱӣHSI

		/* ʹʱ */
  	/* ʹTIM2ʱʱ */
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);

  	/* ʹGPIOAGPIOBGPIOCGPIODAFIOùʱ */
  	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB
					| RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD
					| RCC_APB2Periph_AFIO, ENABLE);    
  }
}

/*******************************************************************************
*   : NVIC_Configuration
*     : STM32жָжϵȼ
*     : 
*     : 
* ֵ  : 
* ˵    : ʼضжԴTIM2ԣȼʹ״̬
*******************************************************************************/
void NVIC_Configuration(void)
{
	NVIC_InitTypeDef NVIC_InitStructure;												//NVICʼṹ,ں趨жϵò

	NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);								//жλ,NVIC_VectTab_FLASHָʾλڲFlashʼλã0x0ƫƵַ
																															//жϷڵʼ㣬ͨڻSTM32׼ĿֻһΡ
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);							//жȼΪ12λռȼ2λӦȼ5ַģʽ
	
	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;							//жţָõǶʱ2ж
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;		//ȼжϵռȼΪ0
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;					//ӦȼжϵȼΪ0
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;							//ʹNVIC
	NVIC_Init(&NVIC_InitStructure);															//NVIC_InitStructureеòӦõNVICУжϵ
}

/*******************************************************************************
*   : Timer2_Init_Config
*     : Timer2ʼ
*     : 
*     : 
*     :  
* ˵    : 
*******************************************************************************/
void Timer2_Init_Config(void)
{
	TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);					//ʹTimer2ʱ
	
	TIM_TimeBaseStructure.TIM_Period = 9;													//һ¼װԶװؼĴڵֵ(10Ϊ1ms)
	TIM_TimeBaseStructure.TIM_Prescaler = 7199;										//ΪTIMxʱƵʳԤƵֵ(10KHzļƵ)
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;				//ʱӷָ:TDTS = TIM_CKD_DIV1
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;		//TIMϼģʽ
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);								//TIM_TimeBaseInitStructָĲʼTIMxʱλ
	 
	TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE );										//ʹTIM2ָж
	
	TIM_Cmd(TIM2, ENABLE);																				//ʹTIMx
}

/*******************************************************************************
*   : TIM2_IRQHandler
*     : ʱ2ж϶Ϸ
*     : 
*     : 
*     :  
* ˵    : 
*******************************************************************************/
void TIM2_IRQHandler(void)
{
	if(TIM_GetITStatus(TIM2, TIM_IT_Update) == SET)
	{
		TIM_ClearITPendingBit(TIM2, TIM_IT_Update);
		Timer2_Counter++;
		W5500_Send_Delay_Counter++;
	}
}

/*******************************************************************************
*   : System_Initialization
*     : STM32ϵͳʼ(ʼSTM32ʱӼ)
*     : 
*     : 
*     :  
* ˵    : 
*******************************************************************************/
void System_Initialization(void)
{
	RCC_Configuration();					//ϵͳʱΪ72MHZ(ԸҪ)
  NVIC_Configuration();					//STM32ж
	SPI_Configuration();					//W5500 SPIʼ(STM32 SPI1)
	Timer2_Init_Config();					//Timer2ʼ
	W5500_GPIO_Configuration();		//W5500 GPIOʼ	
}

/*******************************************************************************
*   : Delay
*     : ʱ(ms)
*     : d:ʱϵλΪ
*     : 
*     :  
* ˵    : ʱTimer2ʱ1ļʵֵ
*******************************************************************************/
void Delay(unsigned int d)
{
	Timer2_Counter = 0; 
	while(Timer2_Counter < d);
}

/*******************************************************************************
*   : W5500_Initialization
*     : W5500ʼ
*     : 
*     : 
* ֵ  : 
* ˵    : 
*******************************************************************************/
void W5500_Initialization(void)
{
	W5500_Init();				//ʼW5500Ĵ
	Detect_Gateway();		//ط 
	Socket_Init(0);			//ָSocket(0~7)ʼ,ʼ˿0
}

/*******************************************************************************
*   : Load_Net_Parameters_Client
*     : װͻģʽ
*     : 
*     : 
* ֵ  : 
* ˵    : ء롢ַIPַ˿ںšĿIPַĿĶ˿ںš˿ڹģʽ
*******************************************************************************/
/**/
//أ192.168.1.1
//:	255.255.255.0
//ַ0C 29 AB 7C 00 01
//IPַ:192.168.1.199
//˿0Ķ˿ںţ5000
//˿0ĿIPַ192.168.1.190
//˿0ĿĶ˿ںţ6000
void Load_Net_Parameters_Client(void)
{
	Gateway_IP[0] = 192;		//ز
	Gateway_IP[1] = 168;
	Gateway_IP[2] = 1;
	Gateway_IP[3] = 1;

	Sub_Mask[0] = 255;			//
	Sub_Mask[1] = 255;
	Sub_Mask[2] = 255;
	Sub_Mask[3] = 0;

	Phy_Addr[0] = 0x0c;			//ַ
	Phy_Addr[1] = 0x29;
	Phy_Addr[2] = 0xab;
	Phy_Addr[3] = 0x7c;
	Phy_Addr[4] = 0x00;
	Phy_Addr[5] = 0x01;

	IP_Addr[0] = 192;				//رIPַ
	IP_Addr[1] = 168;
	IP_Addr[2] = 1;
	IP_Addr[3] = 199;

	S0_Port[0] = 0x13;			//ض˿0Ķ˿ں5000 
	S0_Port[1] = 0x88;

	S0_DIP[0] = 192;				//ض˿0ĿIPַ
	S0_DIP[1] = 168;
	S0_DIP[2] = 1;
	S0_DIP[3] = 190;
	
	S0_DPort[0] = 0x17;			//ض˿0ĿĶ˿ں6000
	S0_DPort[1] = 0x70;

	S0_Mode = TCP_CLIENT;		//ض˿0Ĺģʽ,TCPͻģʽ
}

/*******************************************************************************
*   : Load_Net_Parameters_Server
*     : װ(ģʽ)
*     : 
*     : 
* ֵ  : 
* ˵    : ء롢ַIPַ˿ںšĿIPַĿĶ˿ںš˿ڹģʽ
*******************************************************************************/
/**/
//أ192.168.1.1
//:	255.255.255.0
//ַ0C 29 AB 7C 00 01
//IPַ:192.168.1.199
//˿0Ķ˿ںţ5000
void Load_Net_Parameters_Server(void)
{
	Gateway_IP[0] = 192;		//ز
	Gateway_IP[1] = 168;
	Gateway_IP[2] = 1;
	Gateway_IP[3] = 1;

	Sub_Mask[0] = 255;			//
	Sub_Mask[1] = 255;
	Sub_Mask[2] = 255;
	Sub_Mask[3] = 0;

	Phy_Addr[0] = 0x0c;			//ַ
	Phy_Addr[1] = 0x29;
	Phy_Addr[2] = 0xab;
	Phy_Addr[3] = 0x7c;
	Phy_Addr[4] = 0x00;
	Phy_Addr[5] = 0x01;

	IP_Addr[0] = 192;				//رIPַ
	IP_Addr[1] = 168;
	IP_Addr[2] = 1;
	IP_Addr[3] = 199;

	S0_Port[0] = 0x13;			//ض˿0Ķ˿ں5000 
	S0_Port[1] = 0x88;

	S0_Mode = TCP_SERVER;		//ض˿0Ĺģʽ,TCPģʽ
}

/*******************************************************************************
*   : Load_Net_Parameters_UDP
*     : װ(UDPģʽ)
*     : 
*     : 
* ֵ  : 
* ˵    : ء롢ַIPַ˿ںšĿIPַĿĶ˿ںš˿ڹģʽ
*******************************************************************************/
/**/
//أ192.168.1.1
//:	255.255.255.0
//ַ0C 29 AB 7C 00 01
//IPַ:192.168.1.199
//˿0Ķ˿ںţ5000
void Load_Net_Parameters_UDP(void)
{
	Gateway_IP[0] = 192;		//ز
	Gateway_IP[1] = 168;
	Gateway_IP[2] = 1;
	Gateway_IP[3] = 1;

	Sub_Mask[0] = 255;			//
	Sub_Mask[1] = 255;
	Sub_Mask[2] = 255;
	Sub_Mask[3] = 0;

	Phy_Addr[0] = 0x0c;			//ַ
	Phy_Addr[1] = 0x29;
	Phy_Addr[2] = 0xab;
	Phy_Addr[3] = 0x7c;
	Phy_Addr[4] = 0x00;
	Phy_Addr[5] = 0x01;

	IP_Addr[0] = 192;				//رIPַ
	IP_Addr[1] = 168;
	IP_Addr[2] = 1;
	IP_Addr[3] = 199;

	S0_Port[0] = 0x13;			//ض˿0Ķ˿ں5000 
	S0_Port[1] = 0x88;
	
	UDP_DIPR[0] = 192;			//UDP(㲥)ģʽ,ĿIPַ
	UDP_DIPR[1] = 168;
	UDP_DIPR[2] = 1;
	UDP_DIPR[3] = 190;

	UDP_DPORT[0] = 0x17;		//UDP(㲥)ģʽ,Ŀ˿ں
	UDP_DPORT[1] = 0x70;

	S0_Mode = UDP_MODE;			//ض˿0Ĺģʽ,UDPģʽ
}

/*******************************************************************************
*   : W5500_Socket_Set
*     : W5500˿ڳʼ
*     : 
*     : 
* ֵ  : 
* ˵    : ֱ4˿,ݶ˿ڹģʽ,˿TCPTCPͻ˻UDPģʽ.
*			Ӷ˿״ֽ̬Socket_Stateж϶˿ڵĹ
*******************************************************************************/
void W5500_Socket_Set(void)
{
	if(S0_State == 0)//˿0ʼ
	{
		if(S0_Mode == TCP_SERVER)//TCPģʽ 
		{
			if(Socket_Listen(0) == TRUE)
				S0_State = S_INIT;
			else
				S0_State = 0;
		}
		else if(S0_Mode==TCP_CLIENT)//TCPͻģʽ 
		{
			if(Socket_Connect(0) == TRUE)
				S0_State = S_INIT;
			else
				S0_State = 0;
		}
		else//UDPģʽ 
		{
			if(Socket_UDP(0) == TRUE)
				S0_State = S_INIT|S_CONN;
			else
				S0_State = 0;
		}
	}
}

/*******************************************************************************
*   : Process_Socket_Data
*     : W5500ղͽյ
*     : s:˿ں
*     : 
* ֵ  : 
* ˵    : ȵS_rx_process()W5500Ķ˿ڽݻȡ,
*			Ȼ󽫶ȡݴRx_BufferTemp_Bufferд
*			ϣݴTemp_BufferTx_BufferS_tx_process()
*			ݡ
*******************************************************************************/
void Process_Socket_Data(SOCKET s)
{
	unsigned short size;
	size = Read_SOCK_Data_Buffer(s, Rx_Buffer);
	memcpy(Tx_Buffer, Rx_Buffer, size);			
	Write_SOCK_Data_Buffer(s, Tx_Buffer, size);
}



